' See "Swirl" by Eric W. Weisstein from MathWorld
' A Wolfram Web Resource. http://mathworld.wolfram.com/Swirl.html

Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtN As System.Windows.Forms.TextBox
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtN = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Location = New System.Drawing.Point(0, 24)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(290, 248)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(0, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(16, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "N"
        '
        'txtN
        '
        Me.txtN.Location = New System.Drawing.Point(16, 0)
        Me.txtN.Name = "txtN"
        Me.txtN.Size = New System.Drawing.Size(48, 20)
        Me.txtN.TabIndex = 2
        Me.txtN.Text = "5"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.txtN)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.picCanvas)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_Bm As Bitmap

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DrawSwirl()
        picCanvas.Invalidate()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        DrawSwirl()
        picCanvas.Invalidate()
    End Sub

    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        If m_Bm Is Nothing Then Exit Sub

        e.Graphics.DrawImage(m_Bm, 0, 0)
    End Sub

    Private Sub DrawSwirl()
        Const SCALE As Single = 10

        Dim n As Single
        Try
            n = Single.Parse(txtN.Text)
        Catch ex As Exception
            Exit Sub
        End Try

        m_Bm = New Bitmap(picCanvas.ClientSize.Width, picCanvas.ClientSize.Height)

        Dim cx As Single = m_Bm.Width / 2
        Dim cy As Single = m_Bm.Height / 2
        Dim theta As Single
        For y As Integer = 0 To m_Bm.Height - 1
            Dim dy As Single = (y - cy) / SCALE
            Dim dy2 As Single = dy * dy
            For x As Integer = 0 To m_Bm.Width - 1
                Dim dx As Single = (x - cx) / SCALE
                Dim r As Single = Sqrt(dx * dx + dy2)
                If dx = 0 AndAlso dy = 0 Then
                    theta = 0
                Else
                    theta = Atan2(dy, dx)
                End If
                Dim f As Single = Sin(6 * Cos(r) - n * theta)
                Dim b As Integer = 128 + 127 * f
                m_Bm.SetPixel(x, y, Color.FromArgb(255, 0, 0, b))
            Next x
        Next y
    End Sub

    Private Sub txtN_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtN.TextChanged
        If txtN.Text.Length > 0 Then
            DrawSwirl()
            picCanvas.Invalidate()
        End If
    End Sub
End Class
